///
/// ColumnType.hpp
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

#pragma once

#include <cmath>
#if __has_include(<NitroModules/JSIConverter.hpp>)
#include <NitroModules/JSIConverter.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif
#if __has_include(<NitroModules/NitroDefines.hpp>)
#include <NitroModules/NitroDefines.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif

namespace margelo::nitro::rnnitrosqlite {

  /**
   * An enum which can be represented as a JavaScript enum (ColumnType).
   */
  enum class ColumnType {
    BOOLEAN      SWIFT_NAME(boolean) = 0,
    NUMBER      SWIFT_NAME(number) = 1,
    INT64      SWIFT_NAME(int64) = 2,
    TEXT      SWIFT_NAME(text) = 3,
    ARRAY_BUFFER      SWIFT_NAME(arrayBuffer) = 4,
    NULL_VALUE      SWIFT_NAME(nullValue) = 5,
  } CLOSED_ENUM;

} // namespace margelo::nitro::rnnitrosqlite

namespace margelo::nitro {

  using namespace margelo::nitro::rnnitrosqlite;

  // C++ ColumnType <> JS ColumnType (enum)
  template <>
  struct JSIConverter<ColumnType> final {
    static inline ColumnType fromJSI(jsi::Runtime& runtime, const jsi::Value& arg) {
      int enumValue = JSIConverter<int>::fromJSI(runtime, arg);
      return static_cast<ColumnType>(enumValue);
    }
    static inline jsi::Value toJSI(jsi::Runtime& runtime, ColumnType arg) {
      int enumValue = static_cast<int>(arg);
      return JSIConverter<int>::toJSI(runtime, enumValue);
    }
    static inline bool canConvert(jsi::Runtime&, const jsi::Value& value) {
      if (!value.isNumber()) {
        return false;
      }
      double integer;
      double fraction = modf(value.getNumber(), &integer);
      if (fraction != 0.0) {
        // It is some kind of floating point number - our enums are ints.
        return false;
      }
      // Check if we are within the bounds of the enum.
      return integer >= 0 && integer <= 5;
    }
  };

} // namespace margelo::nitro
