///
/// HybridNativeQueryResultSpec.hpp
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

#pragma once

#if __has_include(<NitroModules/HybridObject.hpp>)
#include <NitroModules/HybridObject.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif

// Forward declaration of `ArrayBuffer` to properly resolve imports.
namespace NitroModules { class ArrayBuffer; }
// Forward declaration of `SQLiteNullValue` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { struct SQLiteNullValue; }
// Forward declaration of `SQLiteQueryColumnMetadata` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { struct SQLiteQueryColumnMetadata; }

#include <optional>
#include <vector>
#include <unordered_map>
#include <string>
#include <variant>
#include <NitroModules/ArrayBuffer.hpp>
#include "SQLiteNullValue.hpp"
#include "SQLiteQueryColumnMetadata.hpp"

namespace margelo::nitro::rnnitrosqlite {

  using namespace margelo::nitro;

  /**
   * An abstract base class for `NativeQueryResult`
   * Inherit this class to create instances of `HybridNativeQueryResultSpec` in C++.
   * You must explicitly call `HybridObject`'s constructor yourself, because it is virtual.
   * @example
   * ```cpp
   * class HybridNativeQueryResult: public HybridNativeQueryResultSpec {
   * public:
   *   HybridNativeQueryResult(...): HybridObject(TAG) { ... }
   *   // ...
   * };
   * ```
   */
  class HybridNativeQueryResultSpec: public virtual HybridObject {
    public:
      // Constructor
      explicit HybridNativeQueryResultSpec(): HybridObject(TAG) { }

      // Destructor
      ~HybridNativeQueryResultSpec() override = default;

    public:
      // Properties
      virtual double getRowsAffected() = 0;
      virtual std::optional<double> getInsertId() = 0;
      virtual std::vector<std::unordered_map<std::string, std::variant<std::string, double, bool, std::shared_ptr<ArrayBuffer>, SQLiteNullValue>>> getResults() = 0;
      virtual std::optional<std::unordered_map<std::string, SQLiteQueryColumnMetadata>> getMetadata() = 0;

    public:
      // Methods
      

    protected:
      // Hybrid Setup
      void loadHybridMethods() override;

    protected:
      // Tag for logging
      static constexpr auto TAG = "NativeQueryResult";
  };

} // namespace margelo::nitro::rnnitrosqlite
