///
/// HybridNitroSQLiteSpec.hpp
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

#pragma once

#if __has_include(<NitroModules/HybridObject.hpp>)
#include <NitroModules/HybridObject.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif

// Forward declaration of `HybridNativeQueryResultSpec` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { class HybridNativeQueryResultSpec; }
// Forward declaration of `ArrayBuffer` to properly resolve imports.
namespace NitroModules { class ArrayBuffer; }
// Forward declaration of `SQLiteNullValue` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { struct SQLiteNullValue; }
// Forward declaration of `BatchQueryResult` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { struct BatchQueryResult; }
// Forward declaration of `NativeBatchQueryCommand` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { struct NativeBatchQueryCommand; }
// Forward declaration of `FileLoadResult` to properly resolve imports.
namespace margelo::nitro::rnnitrosqlite { struct FileLoadResult; }

#include <string>
#include <optional>
#include <memory>
#include "HybridNativeQueryResultSpec.hpp"
#include <vector>
#include <variant>
#include <NitroModules/ArrayBuffer.hpp>
#include "SQLiteNullValue.hpp"
#include <NitroModules/Promise.hpp>
#include "BatchQueryResult.hpp"
#include "NativeBatchQueryCommand.hpp"
#include "FileLoadResult.hpp"

namespace margelo::nitro::rnnitrosqlite {

  using namespace margelo::nitro;

  /**
   * An abstract base class for `NitroSQLite`
   * Inherit this class to create instances of `HybridNitroSQLiteSpec` in C++.
   * You must explicitly call `HybridObject`'s constructor yourself, because it is virtual.
   * @example
   * ```cpp
   * class HybridNitroSQLite: public HybridNitroSQLiteSpec {
   * public:
   *   HybridNitroSQLite(...): HybridObject(TAG) { ... }
   *   // ...
   * };
   * ```
   */
  class HybridNitroSQLiteSpec: public virtual HybridObject {
    public:
      // Constructor
      explicit HybridNitroSQLiteSpec(): HybridObject(TAG) { }

      // Destructor
      ~HybridNitroSQLiteSpec() override = default;

    public:
      // Properties
      

    public:
      // Methods
      virtual void open(const std::string& dbName, const std::optional<std::string>& location) = 0;
      virtual void close(const std::string& dbName) = 0;
      virtual void drop(const std::string& dbName, const std::optional<std::string>& location) = 0;
      virtual void attach(const std::string& mainDbName, const std::string& dbNameToAttach, const std::string& alias, const std::optional<std::string>& location) = 0;
      virtual void detach(const std::string& mainDbName, const std::string& alias) = 0;
      virtual std::shared_ptr<margelo::nitro::rnnitrosqlite::HybridNativeQueryResultSpec> execute(const std::string& dbName, const std::string& query, const std::optional<std::vector<std::variant<std::string, double, bool, std::shared_ptr<ArrayBuffer>, SQLiteNullValue>>>& params) = 0;
      virtual std::shared_ptr<Promise<std::shared_ptr<margelo::nitro::rnnitrosqlite::HybridNativeQueryResultSpec>>> executeAsync(const std::string& dbName, const std::string& query, const std::optional<std::vector<std::variant<std::string, double, bool, std::shared_ptr<ArrayBuffer>, SQLiteNullValue>>>& params) = 0;
      virtual BatchQueryResult executeBatch(const std::string& dbName, const std::vector<NativeBatchQueryCommand>& commands) = 0;
      virtual std::shared_ptr<Promise<BatchQueryResult>> executeBatchAsync(const std::string& dbName, const std::vector<NativeBatchQueryCommand>& commands) = 0;
      virtual FileLoadResult loadFile(const std::string& dbName, const std::string& location) = 0;
      virtual std::shared_ptr<Promise<FileLoadResult>> loadFileAsync(const std::string& dbName, const std::string& location) = 0;

    protected:
      // Hybrid Setup
      void loadHybridMethods() override;

    protected:
      // Tag for logging
      static constexpr auto TAG = "NitroSQLite";
  };

} // namespace margelo::nitro::rnnitrosqlite
